﻿
Imports System.Drawing.Imaging
Imports System.Runtime.InteropServices

Public Class Form1
  Dim bmsize As Integer = 1200
  Dim bitmap As New System.Drawing.Bitmap(bmsize, bmsize)
  Dim bmpdata As New BitmapData
  Dim rgbvalues() As Byte
  Dim Data(bmsize, bmsize) As Integer
  Dim running As Boolean
  Dim x, y, ox, oy As Double
  Dim a, b, c, d As Double
  Dim scalefactor As Integer = 10
  Dim Palettefactor As Integer
  Dim Paletteorder As Integer
  Dim Npoints As Integer = 0
  Dim Maxhit As Integer = 0
  Dim RND As New Random
  Dim IgnoreFlag As Boolean = False
  Dim NP As Integer

  Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
    PictureBox1.BackgroundImage = bitmap
    RadioButton4.Checked = True
    RadioButton7.Checked = True
    ComboBox1.Text = "Classic Barry Martin"
    ResetBitmap()
    Timer1.Interval = 1
  End Sub

  Private Sub ResetBitmap()
    Dim bmsize As Integer = bitmap.Width
    Dim bms As Integer = bmsize \ 2
    If CheckBox2.Checked Then
      FillBitmap(0, 0, bmsize - 1, bmsize - 1, Color.Black)
    Else
      FillBitmap(0, 0, bmsize - 1, bmsize - 1, Color.White)
    End If
    a = NumericUpDown1.Value
    b = NumericUpDown2.Value
    c = NumericUpDown3.Value
    d = NumericUpDown4.Value
    scalefactor = NumericUpDown5.Value
    ClearData()
    If ComboBox1.Text = "Quadratic complex" Then
      LockBitmap()
      x = 0 : y = 0 : ox = 0 : oy = 0
      Dim p, q As Integer
      For i As Integer = 1 To 10000
        x = x - a : y = y - b
        SQRT(x, y)
        p = x * scalefactor + bms
        q = y * scalefactor + bms
        SetRGBvalue((q * bmsize + p) << 2, Color.DarkRed)
      Next
      UnlockBitmap()
    End If
    x = 0 : y = 0 : ox = 0 : oy = 0
    Select Case ComboBox1.Text
      Case "Henon" : x = -0.1
      Case "Simple ellipses" : x = 1
      Case "Duffing" : y = 0.1
      Case "Tinkerbell" : x = -0.5 : ox = 0.15 : oy = 0.4
      Case "Tartan" : x = 0.1
    End Select
    Label10.Text = "Initial point: (" & Format(x, "F") & ", " & Format(y, "F") & ")"
    Npoints = 0 : Maxhit = 0
    Label5.Text = "No. of points:" & Str(Npoints)
    Label6.Text = "Maximum hits:" & Str(Maxhit)
    NP = 0
    PictureBox1.Invalidate()
    PictureBox2.Invalidate()
  End Sub

  Private Sub ClearData()
    For x As Integer = 0 To bmsize
      For y As Integer = 0 To bmsize
        Data(x, y) = 0
      Next
    Next
  End Sub

  Private Sub ResetButton1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
    Stopp()
    bmsize = NumericUpDown6.Value
    bitmap = New Bitmap(bmsize, bmsize)
    PictureBox1.BackgroundImage = bitmap
    ReDim Data(bmsize, bmsize)
    ResetBitmap()
  End Sub

  Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
    GoStop()
  End Sub

  Private Sub GoStop()
    If running Then
      Timer1.Stop() : running = False
      Button2.Text = "Go"
    Else
      Timer1.Start() : running = True
      Button2.Text = "Stop"
    End If
  End Sub

  Private Sub Stopp()
    Timer1.Stop() : running = False
    Button2.Text = "Go"
  End Sub

  Public Sub FillBitmap(x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer, c As Color)
    Dim x, y As Integer
    LockBitmap()
    For y = y1 To y2
      For x = x1 To x2
        SetRGBvalue((y * bmsize + x) << 2, c)
      Next
    Next
    UnlockBitmap()
  End Sub

  Private Sub SetRGBvalue(p As Integer, col As Color)
    rgbvalues(p) = col.B
    rgbvalues(p + 1) = col.G
    rgbvalues(p + 2) = col.R
  End Sub

  Private Sub SetRGBvalue(p As Integer, c As Integer, pf As Integer, po As Integer)
    ' pf = 0 B/W: otherwise blocksize
    ' po = 0: RGB po = 1:GRB: po = 2 BRG: po = 3 grayscale
    Dim r As Integer = p + (po + 2) Mod 3
    Dim g As Integer = p + (po + 1) Mod 3
    Dim b As Integer = p + po Mod 3
    Dim z As Integer = &HFF
    If CheckBox2.Checked Then z = 0
    If po = 3 Then
      c = c * 4
      If c > 255 Then c = 255
      rgbvalues(b) = c Xor z : rgbvalues(g) = c Xor z : rgbvalues(r) = c Xor z
      Exit Sub
    End If
    If pf = 0 Then
      rgbvalues(b) = 255 Xor z : rgbvalues(g) = 255 Xor z : rgbvalues(r) = 255 Xor z
      Exit Sub
    End If
    ' divide c into 6 blocks of palettefactor
    Dim m As Integer = 256 \ pf
    Dim max As Integer = (pf - 1) * m
    If c > 6 * pf Then c = 6 * pf
    Select Case c \ pf
      Case 0 : rgbvalues(b) = 0 Xor z : rgbvalues(g) = 0 Xor z : rgbvalues(r) = c * m Xor z
      Case 1 : rgbvalues(b) = 0 Xor z : rgbvalues(g) = (c - pf) * m Xor z : rgbvalues(r) = max Xor z
      Case 2 : rgbvalues(b) = 0 Xor z : rgbvalues(g) = max Xor z : rgbvalues(r) = max - (c - 2 * pf) * m Xor z
      Case 3 : rgbvalues(b) = (c - 3 * pf) * m Xor z : rgbvalues(g) = max Xor z : rgbvalues(r) = 0 Xor z
      Case 4 : rgbvalues(b) = max Xor z : rgbvalues(g) = max - (c - 4 * pf) * m Xor z : rgbvalues(r) = 0 Xor z
      Case 5 : rgbvalues(b) = max Xor z : rgbvalues(g) = (c - 5 * pf) * m Xor z : rgbvalues(r) = (c - 5 * pf) * m Xor z
      Case 6 : rgbvalues(b) = max Xor z : rgbvalues(g) = max Xor z : rgbvalues(r) = max Xor z
    End Select
  End Sub

  Private Sub LockBitmap()
    ' copies bitmap into byte array
    Dim bounds As Rectangle = New Rectangle(0, 0, bitmap.Width, bitmap.Height)
    bmpdata = bitmap.LockBits(bounds, Imaging.ImageLockMode.ReadWrite, Imaging.PixelFormat.Format32bppRgb)
    Dim total_size As Integer = bmpdata.Stride * bmpdata.Height
    ReDim rgbvalues(total_size)
    Marshal.Copy(bmpdata.Scan0, rgbvalues, 0, total_size)
  End Sub

  Private Sub UnlockBitmap()
    ' copies byte array back into bitmap
    Dim total_size As Integer = bmpdata.Stride * bmpdata.Height
    Marshal.Copy(rgbvalues, 0, bmpdata.Scan0, total_size)
    bitmap.UnlockBits(bmpdata)
  End Sub

  Private Sub Timer1_Tick(sender As Object, e As System.EventArgs) Handles Timer1.Tick
    LockBitmap()
    Calculate(10, bitmap.Width / 2)
    UnlockBitmap()
    If running Then
      Npoints += 1
      Label5.Text = "No. of points:" & Str(Npoints) & " thousand"
      Label6.Text = "Maximum hits:" & Str(Maxhit)
      Label11.Text = "Point: (" & Format(x, "F") & ", " & Format(y, "F") & ")"
    End If
    PictureBox1.Invalidate()
  End Sub

  Private Sub Calculate(n, bms)
    ' calculates n*1000 new points
    Try
      Dim p, q As Integer
      For i As Integer = 1 To n * 1000
        UpdateXY()
        p = (x + ox) * scalefactor + bms
        q = -(y + oy) * scalefactor + bms
        If InsideLimits(p) And InsideLimits(q) Then
          If Data(p, q) = 0 Then Data(p, q) = 20
          Data(p, q) += bitmap.Width \ 600
          If Data(p, q) > Maxhit Then Maxhit = Data(p, q)
          SetRGBvalue((q * bmsize + p) << 2, Data(p, q), Palettefactor, Paletteorder)
        End If
      Next
    Catch ex As Exception
      Label5.Text = "DIVERGENT SERIES"
      Label6.Text = ""
      Timer1.Stop() : running = False
      Button2.Text = "Go"
      My.Computer.Audio.PlaySystemSound(System.Media.SystemSounds.Asterisk)
      Label11.Text = ""
    End Try
  End Sub

  Private Sub UpdateXY()
    Dim zx, zy As Double
    Select Case ComboBox1.Text
      Case "Linear complex"
        zx = a * x - b * y + c
        zy = b * x + a * y
      Case "Quadratic complex"
        zx = x * x - y * y + a
        zy = 2 * x * y + b
      Case "Simple ellipses"
        zx = y + (b * x - c)
        zy = a - x
      Case "Classic Barry Martin"
        zx = y - Math.Sign(x) * Math.Sqrt(Math.Abs(b * x - c))
        zy = a - x
      Case "Positive Barry Martin"
        zx = y + Math.Sign(x) * Math.Sqrt(Math.Abs(b * x - c))
        zy = a - x
      Case "Additive Barry Martin"
        zx = y + Math.Sqrt(Math.Abs(b * x - c))
        zy = a - x
      Case "Sinusoidal Barry Martin"
        zx = y - Math.Sin(b * x - c)
        zy = a - x
      Case "Gingerbread man"
        zx = y + Math.Abs(b * x)
        zy = a - x
      Case "Henon"
        zx = 1 + b * y - c * x * x
        zy = a * x
      Case "Duffing"
        zx = a * x - b * y - x ^ 3
        zy = x
      Case "Tinkerbell"
        zx = x * x - y * y + a * x + b * y
        zy = 2 * x * y + c * x + d * y
      Case "De Jong"
        zx = Math.Sin(a * y) - Math.Cos(b * x)
        zy = Math.Sin(c * x) - Math.Cos(d * y)
      Case "Linton 'Ghost'"
        zx = Math.Sin(a * y) - b * x
        zy = c * x - Math.Cos(d * y)
      Case "Linton 'Tartan'"
        zx = a * y - b * x
        zy = c - x * x
    End Select
    x = zx : y = zy
    NP += 1
    'If NP < 3 Then Debug.Print(Format(x, "F") & ", " & Format(y, "F"))
  End Sub

  Private Sub ComboBox1_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
    Select Case ComboBox1.Text
      Case "Linear complex"
        Label7.Text = "x' = ax - by + c"
        Label8.Text = "y' = bx + ay"
        SetParameters(0.3, 0.95, 1, 0, 100, 1, 7)
      Case "Quadratic complex"
        Label7.Text = "x' = x² - y² + a"
        Label8.Text = "y' = 2xy + b"
        SetParameters(-0.8, 0, 0, 0, 180, 1, 3)
      Case "Simple ellipses"
        Label7.Text = "x' = y + (b*x - c)"
        Label8.Text = "y' = -x + a"
        SetParameters(0, 1.8, 0, 0, 50, 1, 7)
      Case "Classic Barry Martin"
        Label7.Text = "x' = y - sgn(x)√|b*x - c)|"
        Label8.Text = "y' = a - x"
        SetParameters(1, 4, 0.5, 0, 5, 3, 7)
      Case "Positive Barry Martin"
        Label7.Text = "x' = y + sgn(x)√|b*x - c)|"
        Label8.Text = "y' = a - x"
        SetParameters(1, 4, 0.05, 0, 20, 3, 7)
      Case "Additive Barry Martin"
        Label7.Text = "x' = y + √|b*x - c)|"
        Label8.Text = "y' = a - x"
        SetParameters(1, 2, 0, 0, 10, 3, 7)
      Case "Sinusoidal Barry Martin"
        Label7.Text = "x' = y - sin(b*x - c)"
        Label8.Text = "y' = a - x"
        SetParameters(3.2, 1, 0, 0, 10, 3, 7)
      Case "Gingerbread man"
        Label7.Text = "x' = y + abs(b*x)"
        Label8.Text = "y' = a - x"
        SetParameters(1, 1, 0, 0, 10, 4, 7)
      Case "Henon"
        Label7.Text = "x' = 1 + by - cx²"
        Label8.Text = "y' = ax"
        SetParameters(0.5, 0.6, 1.4, 0, 200, 4, 7)
      Case "Duffing"
        Label7.Text = "x' =  ax - by - x³"
        Label8.Text = "y' = x"
        SetParameters(2.75, 0.2, 1, 0, 100, 2, 7)
      Case "Tinkerbell"
        Label7.Text = "x' = (x² - y²) + ax + by"
        Label8.Text = "y' = 2xy + cx + dy"
        SetParameters(0.9, -0.6, 2, 0.5, 180, 4, 15)
      Case "De Jong"
        Label7.Text = "x' = sin(ay) - cos(bx)"
        Label8.Text = "y' = sin(cx) - cos(dy)"
        SetParameters(2, 2.5, 1, 1, 100, 3, 15)
      Case "Linton 'Ghost'"
        Label7.Text = "x' = sin(ay) - bx"
        Label8.Text = "y' = cx - cos(dy)"
        SetParameters(1.2, 0, -1, 2, 100, 3, 15)
      Case "Linton 'Tartan'"
        Label7.Text = "x' = ay - bx"
        Label8.Text = "y' = c - x²"
        SetParameters(1.25, 0.1, 1.1, 0, 200, 3, 7)
    End Select
    ResetBitmap()
  End Sub

  Private Sub SQRT(ByRef x, ByRef y)
    Dim a As Double = x
    Dim b As Double = y
    Dim w As Double = Math.Sqrt(a * a + b * b)
    x = Math.Sqrt((w + a) / 2)
    y = Math.Sqrt((w - a) / 2)
    If b < 0 Then y = -y
    If RND.Next(2) = 1 Then
      x = -x : y = -y
    End If
  End Sub

  Private Sub SetParameters(a, b, c, d, s, r, f)
    IgnoreFlag = True ' only call restbitmap once
    NumericUpDown1.Value = a
    NumericUpDown2.Value = b
    NumericUpDown3.Value = c
    NumericUpDown4.Value = d
    NumericUpDown5.Value = s
    Select Case r
      Case 1 : RadioButton1.Checked = True
      Case 2 : RadioButton2.Checked = True
      Case 3 : RadioButton3.Checked = True
      Case 4 : RadioButton4.Checked = True
      Case 5 : RadioButton5.Checked = True
      Case 6 : RadioButton6.Checked = True
    End Select
    NumericUpDown1.Enabled = f And 1
    NumericUpDown2.Enabled = f And 2
    NumericUpDown3.Enabled = f And 4
    NumericUpDown4.Enabled = f And 8
    IgnoreFlag = False
    ResetBitmap()
    Label10.Text = "Initial point: (" & Format(x, "F") & ", " & Format(y, "F") & ")"
    running = False : GoStop()
  End Sub

  Private Function InsideLimits(f)
    If f < 0 Then Return False
    If f >= bmsize Then Return False
    Return True
  End Function

  Private Sub RadioButton1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles _
    RadioButton1.CheckedChanged, RadioButton2.CheckedChanged, RadioButton3.CheckedChanged, _
    RadioButton4.CheckedChanged, RadioButton5.CheckedChanged, RadioButton6.CheckedChanged
    If sender.checked Then
      Palettefactor = sender.tag
    End If
  End Sub

  Private Sub RadioButton9_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles _
    RadioButton7.CheckedChanged, RadioButton8.CheckedChanged, RadioButton9.CheckedChanged, RadioButton10.CheckedChanged
    If sender.checked Then
      Paletteorder = sender.tag
      PictureBox2.Invalidate()
    End If
  End Sub

  Private Sub SaveImageButton3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
    Stopp()
    SaveFileDialog1.FileName = ComboBox1.Text & Str(a) & Str(b) & Str(c) & Str(d) & Str(scalefactor) & ".gif"
    If SaveFileDialog1.ShowDialog = DialogResult.OK Then
      bitmap.Save(SaveFileDialog1.FileName, ImageFormat.Gif)
    End If
  End Sub
  Private Sub NumericUpDown1_ValueChanged(sender As System.Object, e As System.EventArgs) Handles _
    NumericUpDown1.ValueChanged, NumericUpDown2.ValueChanged, NumericUpDown3.ValueChanged, _
    NumericUpDown4.ValueChanged, NumericUpDown5.ValueChanged
    If IgnoreFlag Then Exit Sub
    ResetBitmap()
    Label10.Text = "Initial point: (" & Format(x, "F") & ", " & Format(y, "F") & ")"
    running = False : GoStop()
  End Sub
  Private Sub PictureBox1_MouseClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseClick
    If e.Button = Windows.Forms.MouseButtons.Left Then ResetBitmap()
    x = (e.X - bitmap.Width / 2) / scalefactor
    y = -(e.Y - bitmap.Width / 2) / scalefactor
    Label10.Text = "Initial point: (" & Format(x, "F") & ", " & Format(y, "F") & ")"
    running = False : GoStop()
  End Sub

  Private Sub PictureBox1_Paint(sender As Object, e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
    Dim bms = 300
    If CheckBox1.Checked Then
      e.Graphics.DrawLine(Pens.Gray, bms, bms - 10, bms, bms + 10)
      e.Graphics.DrawLine(Pens.Gray, bms - 10, bms, bms + 10, bms)
      e.Graphics.DrawEllipse(Pens.Gray, bms - scalefactor, bms - scalefactor, scalefactor * 2, scalefactor * 2)
    End If
  End Sub

  Private Sub CheckBox1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox1.CheckedChanged
    PictureBox1.Invalidate()
  End Sub

  Private Sub Button4_Click(sender As System.Object, e As System.EventArgs) Handles Button4.Click
    Help.Show()
  End Sub

  Private Sub PictureBox2_Paint(sender As Object, e As System.Windows.Forms.PaintEventArgs) Handles PictureBox2.Paint
    Dim Pen As New Pen(Color.Black)
    For i As Integer = 0 To 134
      SetRGBvalue(0, i, 22, Paletteorder)
      Pen.Color = Color.FromArgb(rgbvalues(2), rgbvalues(1), rgbvalues(0))
      e.Graphics.DrawLine(Pen, i, 0, i, 20)
    Next
  End Sub

End Class

